# IEx3DEditorHostPanePart Struct Reference
[External Interfaces]

Inheritance diagram for IEx3DEditorHostPanePart:

List of all members.

## Public Member Functions
virtual MCCOMErr MCCOMAPI | ReRender (boolean invalidate, boolean cameraChanged)=0
virtual MCCOMErr MCCOMAPI | DrawInstances (const TRenderableAndTfmArray &instances)=0
virtual void MCCOMAPI | Pick (const TMCPoint &mousePos, TRenderPickArray &picks)=0
virtual void MCCOMAPI | SelfDraw ()=0
virtual void MCCOMAPI | PixelRay (const TMCPoint &pixelPos, TVector3 &worldOrigin, TVector3 &worldDirection)=0
virtual void MCCOMAPI | Set3DEditorHostPanePart (I3DEditorHostPanePart *editorHostPanePart)=0
virtual MCCOMErr MCCOMAPI | InvalidateRender (boolean invalidate, boolean cameraChanged)=0
virtual MCCOMErr MCCOMAPI | SelfRenderDraw (TRenderable2DArray &renderables2D)=0
virtual MCCOMErr MCCOMAPI | SelfRenderPickDraw (I3DExPickRenderer *pickRenderer)=0
virtual MCCOMErr MCCOMAPI | GetLocationOfSelectionInGlobal (TVector3 &outGlobalLocation)=0
virtual boolean MCCOMAPI | GetHitLocationInGlobal (const TMCPoint &inWindowPoint, TVector3 &outGlobalLocation)=0
virtual void MCCOMAPI | GetCurrentScene (I3DShScene **scene, boolean createIfNone)=0
| Return the scene that should be renderered in this view ( in case of a modeler,.
virtual void MCCOMAPI | GetCameraToolsStatus (TCameraToolsStatus &outStatus, boolean &outAllowSavePos)=0
virtual I3DEditorHostPanePart *MCCOMAPI | Get3DEditorHostPanePart () const =0
virtual void MCCOMAPI | BeginAreaRender ()=0
virtual void MCCOMAPI | EndAreaRender ()=0
virtual void MCCOMAPI | CameraMoved ()=0

## Detailed Description

Derive your own part from this class to implement your own 3D Editor host panes.

## Member Function Documentation

virtual void MCCOMAPI IEx3DEditorHostPanePart::BeginAreaRender | ( |  | ) | `[pure virtual]`

Called before starting an area render.

Implemented in TBasic3DEditorHostPanePart.

virtual void MCCOMAPI IEx3DEditorHostPanePart::CameraMoved | ( |  | ) | `[pure virtual]`

Alerts the pane part that the camera has moved

Implemented in TBasic3DEditorHostPanePart.

virtual MCCOMErr MCCOMAPI IEx3DEditorHostPanePart::DrawInstances | ( | const TRenderableAndTfmArray & | instances | ) | `[pure virtual]`

virtual void MCCOMAPI IEx3DEditorHostPanePart::EndAreaRender | ( |  | ) | `[pure virtual]`

Called at the end of an area render.

Implemented in TBasic3DEditorHostPanePart.

virtual I3DEditorHostPanePart* MCCOMAPI IEx3DEditorHostPanePart::Get3DEditorHostPanePart | ( |  | ) | const`[pure virtual]`

Returns a pointer to the associated pane part.

Implemented in TBasic3DEditorHostPanePart.

virtual void MCCOMAPI IEx3DEditorHostPanePart::GetCameraToolsStatus | ( | TCameraToolsStatus & | outStatus,
|  | boolean & | outAllowSavePos |
| ) |  |  | `[pure virtual]`

Returns the enable status that the 3deditor host should give to the camera tools

Parameters:

  | outStatus | Status to give to the camera tools
  | outAllowSavePos | True if camera's position should be saved (false for canonical views)

Implemented in TBasic3DEditorHostPanePart.

virtual void MCCOMAPI IEx3DEditorHostPanePart::GetCurrentScene | ( | I3DShScene ** | scene,
|  | boolean | createIfNone |
| ) |  |  | `[pure virtual]`

Return the scene that should be renderered in this view ( in case of a modeler,.

Parameters:

  | scene | The scene that is returned.
  | createIfNone | Set this to true to ask a modeler to create its scene ( otherwise the scene returned by a modeler is NULL )

Implemented in TBasic3DEditorHostPanePart.

virtual boolean MCCOMAPI IEx3DEditorHostPanePart::GetHitLocationInGlobal | ( | const TMCPoint & | inWindowPoint,
|  | TVector3 & | outGlobalLocation |
| ) |  |  | `[pure virtual]`

Return the location of the hit in global coordinates.

Parameters:

  | inWindowPoint | The position in window coordinates
  | outGlobalLocation | The position in global coordinates

Implemented in TBasic3DEditorHostPanePart.

virtual MCCOMErr MCCOMAPI IEx3DEditorHostPanePart::GetLocationOfSelectionInGlobal | ( | TVector3 & | outGlobalLocation | ) | `[pure virtual]`

Implemented in TBasic3DEditorHostPanePart.

virtual MCCOMErr MCCOMAPI IEx3DEditorHostPanePart::InvalidateRender | ( | boolean | invalidate,
|  | boolean | cameraChanged |
| ) |  |  | `[pure virtual]`

Called by 3DEditorHostPart when something like a camera change causes need for a re-render. If you are using 3DEditorHostPanePartRenderDraw just call 3DEditorHostPanePartInvalidateRender

Parameters:

  | invalidate |
  | cameraChanged |

Implemented in TBasic3DEditorHostPanePart.

virtual void MCCOMAPI IEx3DEditorHostPanePart::Pick | ( | const TMCPoint & | mousePos,
|  | TRenderPickArray & | picks |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IEx3DEditorHostPanePart::PixelRay | ( | const TMCPoint & | pixelPos,
|  | TVector3 & | worldOrigin,
|  | TVector3 & | worldDirection |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IEx3DEditorHostPanePart::ReRender | ( | boolean | invalidate,
|  | boolean | cameraChanged |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IEx3DEditorHostPanePart::SelfDraw | ( |  | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IEx3DEditorHostPanePart::SelfRenderDraw | ( | TRenderable2DArray & | renderables2D | ) | `[pure virtual]`

This function is called by 3DEditorHostPanePartRenderDraw to allow the extension to create a renderable array and call DrawInstances on the interactive renderer

virtual MCCOMErr MCCOMAPI IEx3DEditorHostPanePart::SelfRenderPickDraw | ( | I3DExPickRenderer * | pickRenderer | ) | `[pure virtual]`

This function is called by 3DEditorHostPanePartPick to allow the extension to create a renderable array for picking and call PickInstances on the pickRenderer

Parameters:

  | pickRenderer |

Implemented in TBasic3DEditorHostPanePart.

virtual void MCCOMAPI IEx3DEditorHostPanePart::Set3DEditorHostPanePart | ( | I3DEditorHostPanePart * | editorHostPanePart | ) | `[pure virtual]`

This function is called when the 3DEditorHostPanePart extension is attached

Parameters:

  | editorHostPanePart |

Implemented in TBasic3DEditorHostPanePart.

The documentation for this struct was generated from the following files:

- I3DExEditorPart.h
- IEx3DEditorHostPart.h